﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace XamScheduleDemo
{
    public partial class MainPage : UserControl
    {
        public ObservableCollection<Appointment> Appointments { get; set; }

        public ObservableCollection<ResourceCalendar> Calendars { get; set; }

        public ObservableCollection<Resource> ResourceItems { get; set; }

        public MainPage()
        {
            InitializeComponent();
            this.DataContext = this;
            Loaded += new RoutedEventHandler(CalendarMonth_Loaded);
        }

        void CalendarMonth_Loaded(object sender, RoutedEventArgs e)
        {
            ResourceItems = new ObservableCollection<Resource>();
            ResourceItems.Add(new Resource() { Id = "resource1" });

            Calendars = new ObservableCollection<ResourceCalendar>();
            Calendars.Add(new ResourceCalendar() { Id = "calendar1", OwningResourceId = "resource1" });

            Appointments = new ObservableCollection<Appointment>();
            Appointments.Add(new Appointment() { Id = "1", Start = DateTime.UtcNow, End = DateTime.UtcNow.AddHours(1), Subject = "test", OwningCalendarId = "calendar1", OwningResourceId = "resource1" });
        }

        public class Appointment
        {
            public string Id { get; set; }
            public DateTime Start { get; set; }
            public DateTime End { get; set; }
            public string OwningResourceId { get; set; }
            public string OwningCalendarId { get; set; }
            public string Subject { get; set; }
            public string Location { get; set; }
            public string Description { get; set; }
            public string StartTimeZoneId { get; set; }
            public string EndTimeZoneId { get; set; }

            #region TimeZoneNeutral

            public bool IsTimeZoneNeutral { get; set; }

            #endregion // TimeZoneNeutral

            #region Recurrece

            public string Recurrence { get; set; }
            public DateTime MaxOccurrenceDateTime { get; set; }
            public string RootActivityId { get; set; }
            public DateTime OriginalOccurrenceStart { get; set; }
            public DateTime OriginalOccurrenceEnd { get; set; }
            public bool IsOccurrenceDeleted { get; set; }
            public long VariantProperties { get; set; }
            public int RecurrenceVersion { get; set; }

            #endregion // Recurrece

            #region Reminders

            public bool ReminderEnabled { get; set; }
            public TimeSpan ReminderInterval { get; set; }
            public string Reminder { get; set; }

            #endregion // Reminders
        }

        public class Resource
        {
            public string Id { get; set; }
        }

        public class ResourceCalendar
        {
            public string Id { get; set; }
            public string OwningResourceId { get; set; }
        }
    }
}
